diff -rupN /usr/src/linux-2.4.9/mm/filemap.c linux-kgdb/mm/filemap.c
--- /usr/src/linux-2.4.9/mm/filemap.c	Fri Aug 24 00:13:25 2001
+++ linux-kgdb/mm/filemap.c	Sun Aug 26 20:36:51 2001
@@ -1221,6 +1247,1329 @@ int file_read_actor(read_descriptor_t * 
 	desc->buf += size;
 	return size;
 }
+
+#if defined(CONFIG_AIO)
+
+static unsigned long 	kaio_hash_mask = 0;
+static kaiocb_t 	**kaio_hash_table;
+static int		kaio_hash_table_size;
+static int		kaio_number = 1;  	/* id for kaio 		*/
+static int		kaio_nr_hashed = 0;
+static spinlock_t 	kaio_hash_lock = SPIN_LOCK_UNLOCKED;
+
+typedef struct {
+	spinlock_t kaioq_lock;
+	struct semaphore kaiosem;
+
+	/* 0x10 */
+	struct list_head kaioq;
+	int		 kaioqref;
+	volatile int	 kaioq_nslaves;
+
+	/* 0x20 */
+	struct semaphore kaioq_exit_sem;
+} kaio_queue_t;
+
+#define KAIO_INFO(task) ((kaio_queue_t *) (task)->kaio_info)
+
+static inline unsigned long
+kaio_time(void)
+{
+	struct timeval tv;
+
+	do_gettimeofday(&tv);
+	return (tv.tv_sec * 1000000 + tv.tv_usec);
+}
+
+/*
+ * AIO HASH TABLE:
+ * 	A simple system wide table hashed on kq & aio_id. 
+ *	Most of this code adapted from the buffer cache hash table.
+ *	All operations protected by kernel lock.
+ */
+#define _kaio_hashfn(kq, kid)	((unsigned)(((unsigned)kq)^(kid)) & kaio_hash_mask)
+#define kaio_hash(kq, kid)	kaio_hash_table[_kaio_hashfn((kq),(kid))]
+
+static void
+kaio_init_hash_table(void)
+{
+	int order = 1;		/* Currently maximum order.. */
+
+	kaio_hash_table_size = (1UL << order) * PAGE_SIZE / sizeof(kaiocb_t *);
+	kaio_hash_table = (kaiocb_t  **) __get_free_pages(GFP_ATOMIC, order);
+	
+	if (!kaio_hash_table)
+		panic("Failed to allocate kaio hash table\n");
+	memset(kaio_hash_table, 0, kaio_hash_table_size * sizeof(kaiocb_t *));
+	kaio_hash_mask = kaio_hash_table_size-1;
+}
+
+static void
+kaio_add_hash(kaiocb_t *kaiocb)
+{
+	kaiocb_t **khp;
+	kaiocb_t *next;
+
+	spin_lock(&kaio_hash_lock);
+	kaiocb->kaio_id = kaio_number++; /* XXX: how about overflow? */
+	khp = &kaio_hash(current->kaio_info, kaiocb->kaio_id);
+	next = *khp;
+
+	kaiocb->kaio_h_next = NULL;
+	kaiocb->kaio_h_pprev = NULL;
+
+	if (next) {
+		kaiocb->kaio_h_next = next;
+		next->kaio_h_pprev = &kaiocb->kaio_h_next;
+	}
+	*khp = kaiocb;
+	kaiocb->kaio_h_pprev = khp;
+	kaio_nr_hashed++;
+	spin_unlock(&kaio_hash_lock);
+}
+
+static kaiocb_t *
+kaio_find_hash(kaio_key_t *kkey)
+{		
+	kaiocb_t *next;
+
+	next = kaio_hash(KAIO_INFO(current), kkey->kaio_kid);
+	for (;;) {
+		kaiocb_t *tmp = next;
+		if (!next)
+			break;
+		next = tmp->kaio_h_next;
+		if (tmp->kaio_id != kkey->kaio_kid)
+			continue;
+		assert(tmp->kaio_task->kaio_info == kkey->kaio_kq);
+		next = tmp;
+		break;
+	}
+	return next;
+}
+
+static inline void
+kaio_remove_hash(kaiocb_t *kaiocb)
+{
+	kaiocb_t **pprev = kaiocb->kaio_h_pprev;
+	if (pprev) {
+		kaiocb_t *next = kaiocb->kaio_h_next;
+		if (next) {
+			next->kaio_h_pprev = pprev;
+			kaiocb->kaio_h_next = NULL;
+		}
+		*pprev = next;
+		kaiocb->kaio_h_pprev = NULL;
+	}
+	kaio_nr_hashed--;
+}
+
+/*
+ * PER-TASK AIO QUEUE OPERATIONS.
+ * 	Proceted by a spinlock embedded in the queue.
+ */
+
+
+/*
+ * Create: an aio queue for the given task. A q create is attempted as 
+ * part of all aio operations, including the slave start operation.
+ * The queue is freed as part of exit. 
+ */
+void
+kaio_q_create(struct task_struct *task)
+{
+	struct task_struct 	*p;
+	kaio_queue_t		*kq;
+
+	/* protected by lock_kernel */
+	if (KAIO_INFO(task))
+		return;
+
+	kq = kmalloc(sizeof(kaio_queue_t), GFP_KERNEL);
+
+	if (!kq) {
+		printk("kmalloc KAIO_INFO(task) failed!!\n");
+		do_exit(SIGKILL);
+	}
+	/*
+	 * XXX: the following memset is required
+	 * in spite of individual member initializaion of
+	 * kaio_queue_t. why?
+	 */
+	memset(&kq->kaioq_lock, 0, sizeof(kaio_queue_t));
+	sema_init(&kq->kaiosem, 0);
+	sema_init(&kq->kaioq_exit_sem, 0);
+	INIT_LIST_HEAD(&kq->kaioq);
+	spin_lock_init(&kq->kaioq_lock);
+
+	kq->kaioq_nslaves = -1; /* -1 indicates no slaves yet */
+	/*
+	 * If there are any clones, propage kaio_info.
+	 * Following will automatically set current task kaioq & reference.
+	 */
+	kq->kaioqref = 0;
+	for_each_task(p) {
+		if (p->mm == current->mm) {
+			KAIO_INFO(p) = kq;
+			kq->kaioqref++;
+		}
+	}
+	
+}
+
+
+/*
+ * Enqueue: now the aio is officially enqueued for I/O, accessible to the slave
+ * 	threads, and is also entered into the hash table, accessible to
+ * 	user operations such as aio_suspend.
+ */
+static int
+kaio_enqueue(kaio_queue_t *kq, kaiocb_t *kaiocb)
+{
+	kaiocb->kaio_error = EINPROGRESS;
+	if (put_user(kaiocb->kaio_error, &kaiocb->kaio_uaiocb->aio_error))
+		return(-EFAULT);
+	kaiocb->kaio_suspend_wait = 0;
+	INIT_LIST_HEAD(&kaiocb->kaio_ioq);
+
+	spin_lock(&kq->kaioq_lock);
+	if (kq->kaioq_nslaves == 0) {
+		spin_unlock(&kq->kaioq_lock);
+		return -EAGAIN;
+		
+	}
+	kaio_add_hash(kaiocb);
+	list_add(&kaiocb->kaio_ioq, &kq->kaioq);
+	up(&kq->kaiosem);
+	spin_unlock(&kq->kaioq_lock);
+
+        kaio_set_time(kaiocb, AIOTIME_ENQUEUED);
+
+        return 0;
+}
+
+/*
+ * Wait for an aio and dequeue. Normally, kaiosem counts the number
+ * of entries available in the queue; however, kaio_cancel can
+ * dequeue entries as well, and it does not down the semaphore,
+ * because there is no easy way to synchronize this action with kaio_dequeue.
+ * Instead, the dequeue operation simply retries if it finds the queue
+ * empty eventhough the semaphore count was non-zero (i.e. the down succeded).
+ * The down() is interrupted when the parent sends a signal when it exits.
+ */
+static kaiocb_t *
+kaio_dequeue(kaio_queue_t *kq)
+{
+	struct list_head *tmp;
+
+retry:
+	if (down_interruptible(&kq->kaiosem))
+		return 0;
+
+	spin_lock(&kq->kaioq_lock);
+	tmp = kq->kaioq.prev;
+	if (tmp != &kq->kaioq) {
+		list_del(tmp);
+		spin_unlock(&kq->kaioq_lock);
+		INIT_LIST_HEAD(tmp);
+		return(list_entry(tmp, struct kaiocb, kaio_ioq));
+	} else {
+		spin_unlock(&kq->kaioq_lock);
+		goto retry;
+	}
+}
+
+static int
+kaio_dequeue_kaiocb(kaio_queue_t *kq, kaiocb_t *kaiocb)
+{
+	spin_lock(&kq->kaioq_lock);
+	if (kaiocb->kaio_ioq.prev == &kaiocb->kaio_ioq) {
+		assert(kaiocb->kaio_ioq.next == &kaiocb->kaio_ioq);
+		spin_unlock(&kq->kaioq_lock);
+		return 0;
+	}
+	list_del(&kaiocb->kaio_ioq);
+	INIT_LIST_HEAD(&kaiocb->kaio_ioq);
+	spin_unlock(&kq->kaioq_lock);
+	return 1;
+}
+
+static kaiocb_t *
+kaio_dequeue_fd(kaio_queue_t *kq, struct file *filp)
+{
+	struct list_head *tmp;
+	kaiocb_t *kaiocb;
+
+	spin_lock(&kq->kaioq_lock);
+	tmp = kq->kaioq.next; /* start from first of list; why not? */
+	while (tmp != &kq->kaioq) {
+		kaiocb = list_entry(tmp, struct kaiocb, kaio_ioq);
+		if (kaiocb->kaio_filp == filp) {
+			list_del(tmp);
+			spin_unlock(&kq->kaioq_lock);
+			INIT_LIST_HEAD(tmp);
+			return(kaiocb);
+		}
+		tmp = tmp->next;
+	}
+	spin_unlock(&kq->kaioq_lock);
+	return 0;
+}
+
+/*
+ * Boot time initialization.
+ */
+void
+kaio_init(void)
+{
+	kaio_init_hash_table();
+}
+
+static void
+send_signal(sigevent_t *sigev, struct task_struct *task)
+{
+	if (sigev->sigev_notify == SIGEV_SIGNAL) {
+		struct siginfo sinfo;
+                int r;
+		
+		memset(&sinfo, 0, sizeof(sinfo));
+		sinfo.si_signo = sigev->sigev_signo;
+		sinfo.si_code = SI_ASYNCIO;
+		sinfo.si_value = sigev->sigev_value;
+
+                /* signal queue items are allocated at GFP_ATOMIC, so
+                   -EAGAIN is possible.  We don't want to lose
+                   completion signals, really, so don't leave before
+                   we succeed queuing the signal. */
+        retry:
+                r = send_sig_info(sigev->sigev_signo, &sinfo, task);
+                if (r == -EAGAIN) {
+                        schedule ();
+                        goto retry;
+                }
+	}
+}
+
+static int
+lio_complete(liocb_t *liocb, int n, int wakeup)
+{
+	spin_lock(&liocb->lio_lock);
+	liocb->lio_done += n;
+	if (liocb->lio_nent == liocb->lio_done) {
+		spin_unlock(&liocb->lio_lock);
+		if (wakeup) {
+			lock_kernel();
+			wake_up(&liocb->lio_wait);
+			unlock_kernel();
+		}
+		send_signal(&liocb->lio_sigevent, liocb->lio_task);
+		if (liocb->lio_mode == LIO_NOWAIT)
+			kfree(liocb);
+		return 1;
+	}
+	if (!wakeup)
+		lock_kernel();
+	spin_unlock(&liocb->lio_lock);
+	return 0;
+}
+
+static int
+kaio_io_complete(kaiocb_t *kaiocb, int nbytes, int ret, int gc)
+{
+	aiocb_t	*uaiocb = kaiocb->kaio_uaiocb;
+	liocb_t	*liocb = kaiocb->kaio_liocb;
+	int	i;
+
+	if (kaiocb->kaio_pages) {
+
+		for (i = 0; i < kaiocb->kaio_npages; i++)
+			page_cache_release(kaiocb->kaio_pages[i]);
+		if (kaiocb->kaio_pages != &kaiocb->kaio_page_inline)
+			kfree(kaiocb->kaio_pages);
+	}
+
+#ifdef KAIO_STATS
+        kaio_set_time(kaiocb, AIOTIME_COMPLETE);
+	if (copy_to_user(&uaiocb->aio_times[1], &kaiocb->kaio_times[1],
+			sizeof(unsigned long) * (AIO_TIMES-1)))
+	{
+		ret = -EFAULT;
+	} else
+#endif
+	if (put_user(nbytes, &uaiocb->aio_return))
+		ret = -EFAULT;
+	/* aio_error does not go through syscall so -ret */
+	else if (put_user(-ret, &uaiocb->aio_error))
+		ret = -EFAULT;
+	else {
+		send_signal(&kaiocb->kaio_sigevent, kaiocb->kaio_task);
+		spin_lock(&kaio_hash_lock);
+		if (kaiocb->kaio_suspend_wait) {
+			lock_kernel();
+			kaiocb->kaio_error = -ret;
+			wake_up(kaiocb->kaio_suspend_wait);
+			unlock_kernel();
+		} else {
+			kaiocb->kaio_error = -ret;
+			/* gc |= (liocb && liocb->lio_mode == LIO_WAIT); */
+			gc = 1;
+			if (gc)
+				kaio_remove_hash(kaiocb);
+		}
+		spin_unlock(&kaio_hash_lock);
+		if (liocb)
+			lio_complete(liocb, 1, 1);
+	}
+	if (gc) {
+		fput(kaiocb->kaio_filp);
+		kfree(kaiocb);
+	}
+	return ret;
+}
+
+static int
+kaio_slave_suspend(kaiocb_t *kaiocb)
+{
+	off_t pos;
+	int i, ret = 0, nbytes, isize;
+	struct page *page;
+
+	nbytes = kaiocb->kaio_nbytes;
+	isize = kaiocb->kaio_filp->f_dentry->d_inode->i_size;
+	for (i = 0; i < kaiocb->kaio_npages; i++) {
+		page = kaiocb->kaio_pages[i];
+		wait_on_page(page);
+		/*
+		 * Ok, we have the page. 
+		 */
+		if (!Page_Uptodate(page) || PageError(page)) {
+			ret = -EIO; /* Some unspecfied error */
+			goto error;
+		}
+	}
+	kaio_set_time(kaiocb, AIOTIME_IO);
+
+	pos = kaiocb->kaio_offset;
+	i = 0;
+	page = kaiocb->kaio_pages[0];
+	assert(nbytes);
+
+	while  (nbytes && pos < isize) {
+		unsigned long offset, nr, left;
+
+		offset = pos & ~PAGE_MASK;
+		nr = PAGE_SIZE - offset;
+		if (nr > isize - pos)
+			nr = isize - pos;
+		if (nbytes < nr)
+			nr = nbytes;
+
+		left = __copy_to_user(kaiocb->kaio_buf,
+				(char *) page_address(page) + offset, nr);
+		nbytes -= (nr - left);
+		if (left) {
+			ret = -EFAULT;
+			goto error; 
+		}
+		pos += nr;
+		kaiocb->kaio_buf = (char *)kaiocb->kaio_buf + nr;
+		if ((pos & ~PAGE_MASK) == 0) { /* beginning of next page */
+			i++;
+			page = kaiocb->kaio_pages[i];
+		}
+	}
+	assert(!nbytes || pos == isize);
+	kaio_set_time(kaiocb, AIOTIME_COPY);
+
+error:
+
+	/* nbytes contains remainder unread, for eg., due to isize limit */
+	ret = kaio_io_complete(kaiocb, kaiocb->kaio_nbytes - nbytes, ret, 0);
+
+	return ret;
+}
+
+#if defined(CONFIG_RAW)
+static int
+do_raw_wait(kaiocb_t *kaiocb)
+{
+	int diag;
+
+	do {
+		diag = kaio_raw_wait(kaiocb->kaio_scp, &kaiocb->kaio_iobuf);
+	} while (diag == -EAGAIN);
+	diag = kaio_io_complete(kaiocb, diag, (diag > 0 ? 0 : diag), 0);
+	return diag;
+}
+
+static int
+do_kaio_raw_rw(int cmd, struct file *filp, struct kaiocb *kaiocb)
+{
+	int diag;
+	void *scp;
+
+	kaiocb->kaio_sem = MUTEX_LOCKED;
+	scp = kaio_raw_rw((cmd == AIOCMD_READ ? READ : WRITE), filp,
+			kaiocb->kaio_buf, kaiocb->kaio_nbytes,
+			&kaiocb->kaio_offset, &diag,
+			&kaiocb->kaio_sem, &kaiocb->kaio_iobuf);
+	kaiocb->kaio_scp = scp;
+	if (diag == 0) {
+		diag = kaio_enqueue(KAIO_INFO(current), kaiocb);
+		if (diag) {
+			do {
+				diag = kaio_raw_wait(kaiocb->kaio_scp,
+					&kaiocb->kaio_iobuf);
+			} while (diag == -EAGAIN);
+		}
+	}
+	return diag;
+}
+#endif /* CONFIG_RAW */
+
+kaiocb_t *susp_kaiocb;
+
+int
+kaio_suspend(aiocb_t *list[], int nent, struct timespec *utimeout, int nwait)
+{
+	int 			ret = 0, i, valid, pending;
+	struct timespec 	timeout;
+	aiocb_t			*uaiocb = 0;
+	kaio_key_t		kkey;
+	kaiocb_t 		*kaiocb, **kaiocbs, *kaiocb_array[256];
+	wait_queue_head_t	wq;
+	DECLARE_WAITQUEUE(wait, current);
+
+	if (utimeout && copy_from_user(&timeout, (struct timespec *)utimeout,
+				    sizeof(struct timespec)))
+	{
+		return -EFAULT;
+	}
+	/*
+	 * For more normal requests, allocate on stack.
+	 */
+	if (nent > 256) {
+		kaiocbs = kmalloc(sizeof(kaiocb_t *) * nent, GFP_KERNEL);
+		if (!kaiocbs)
+			return -EAGAIN;
+	} else
+		kaiocbs = kaiocb_array;
+
+	init_waitqueue_head(&wq);
+	add_wait_queue(&wq, &wait);
+
+	/*
+	 * Go through the list, if nwait done, return; otherwise
+	 * mark kaiocb so it will wake this thread when done.
+	 */
+	for (i = 0, valid = 0; nwait > 0 && i < nent; i++) {
+		if (get_user(uaiocb, &list[i])) {
+			ret = -EFAULT;
+			goto suspend_error;
+		}
+		if (!uaiocb)
+			continue;
+		/*
+		 * Check to see if done, otherwise put this
+		 * thread on the list of things to wake up.
+		 */
+		if (copy_from_user(&kkey, &uaiocb->aio_key,
+			sizeof(kaio_key_t)))
+		{
+			ret = -EFAULT;
+			goto suspend_error;
+		}
+		spin_lock(&kaio_hash_lock);
+		if ((kaiocb = kaio_find_hash(&kkey)) == 0) {
+			/* get_user can fault, better drop lock */
+			spin_unlock(&kaio_hash_lock);
+			if (get_user(ret, &uaiocb->aio_error)) {
+				ret = -EFAULT;
+				goto suspend_error;
+			}
+			/*
+			 * Assume that user gave a valid aiocb,
+			 * and that it is done.
+			 */
+			nwait--;
+		} else {
+			if (kaiocb->kaio_suspend_wait) {
+				/*
+				 * Don't allow two different processes to
+				 * wait on the same I/O request.
+				 */
+				ret = -EAGAIN;
+				spin_unlock(&kaio_hash_lock);
+				goto suspend_error;
+			}
+			kaiocb->kaio_suspend_wait = &wq;
+			kaiocbs[valid++] = kaiocb;
+			spin_unlock(&kaio_hash_lock);
+		}
+	}
+	if (!nwait && !valid)
+		return ret;
+	
+	susp_kaiocb = kaiocbs[0];
+
+	/*
+	 * Pending keeps track of how many I/Os  are being
+	 * wait upon. Valid is the index into kaiocbs where
+	 * the kaiocb of the last pending I/O is stored.
+	 * After sleeping & waking up on any one of the pending
+	 * I/O to complete, we scan the kaiocbs, garbage collect
+	 * all complete kaiocb & put a null entry in kaiocbs[].
+	 */
+	pending = valid;
+	lock_kernel();
+	while (nwait > 0 && pending) {
+		/*
+		 * See how many more done & free kaiocb's as necessary.
+		 */
+		for (i = 0; i < valid; i++) {
+			if (kaiocbs[i]->kaio_error != EINPROGRESS &&
+			     kaiocbs[i]->kaio_suspend_wait)
+			{
+				nwait--;
+				pending--;
+				kaiocbs[i]->kaio_suspend_wait = 0;
+			}
+			/* already done ?! */
+			if (!pending || nwait <= 0)
+				goto done_wait;
+		}
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+		current->state = TASK_INTERRUPTIBLE;
+		if (utimeout)
+			(void) schedule_timeout(timespec_to_jiffies(&timeout));
+		else
+			schedule();
+		current->state = TASK_RUNNING;
+		if (signal_pending(current)) {
+			ret = -ERESTARTSYS;
+			break;
+		}
+	}
+done_wait:
+	unlock_kernel();
+
+suspend_error:
+	spin_lock(&kaio_hash_lock);
+	/*
+	 * Unmark & free kaiocb's as necessary.
+	 */
+	for (i = 0; i < valid; i++) {
+		kaiocbs[i]->kaio_suspend_wait = 0;
+		if (kaiocbs[i]->kaio_error != EINPROGRESS) {
+			kaio_remove_hash(kaiocbs[i]);
+			fput(kaiocbs[i]->kaio_filp);
+			kfree(kaiocbs[i]);
+		}
+	}
+	spin_unlock(&kaio_hash_lock);
+	if (kaiocbs != kaiocb_array)
+		kfree(kaiocbs);
+	return(ret);
+}
+
+/*
+ * kaio_cancel: if given kkey, cancel a specific aio; otherwise
+ * 		cancel all aios for given fd. All successful canceled
+ *		aios will have -1 return & ECANCELED as aio_error.
+ *		kaio_io_complete handles normal signal delivery and
+ *		any listio that the aio may be part of.
+ *	kernel lock held on call.
+ */
+int
+kaio_cancel(int fd, kaio_key_t *kkey)
+{
+	kaiocb_t 	*kaiocb;
+	struct file 	*filp;
+	int		ret = 0;
+
+	if (!(filp = fget(fd)))
+		return -EBADF;
+
+	if (kkey) {
+		spin_lock(&kaio_hash_lock);
+		kaiocb = kaio_find_hash(kkey);
+		spin_unlock(&kaio_hash_lock);
+		if (kaiocb == 0) {
+			ret = -EINVAL;
+			goto cancel_out;
+		}
+
+		if (filp != kaiocb->kaio_filp) {
+			ret = -EBADF;
+			goto cancel_out;
+		}
+
+		if (!kaio_dequeue_kaiocb(KAIO_INFO(current), kaiocb)) {
+			ret = AIO_NOTCANCELED;
+			goto cancel_out;
+		}
+		ret = kaio_io_complete(kaiocb, -1, -ECANCELED, 1);
+		if (ret == 0)
+			ret = AIO_CANCELED;
+	} else {
+		/* cancel all associated with fd */
+		if ((kaiocb = kaio_dequeue_fd(KAIO_INFO(current), filp)) == 0) {
+			ret = AIO_ALLDONE;
+			goto cancel_out;
+		}
+		do {
+			/* XXX: what if error occurs */
+			kaio_io_complete(kaiocb, -1, -ECANCELED, 1);
+		} while ((kaiocb = kaio_dequeue_fd(KAIO_INFO(current), filp)) != 0);
+	}
+cancel_out:
+	fput(filp);
+	return ret;
+}
+
+void
+kaio_fork(struct task_struct *p, int clone_flags)
+{
+	/* Assumes kernel lock held */
+
+	/*
+	 * If the new thread is not sharing VM with parent,
+	 * then it can't share AIO state.
+	 */
+	if (clone_flags & CLONE_VM) {
+		KAIO_INFO(p) = KAIO_INFO(current);
+		KAIO_INFO(p)->kaioqref++;
+	} else
+		p->kaio_info = 0;
+}
+
+/*
+ * kaio_exit:
+ *	Called by generic exit when a thread has async I/O (kaio_info).
+ *	This routine does the following:
+ * 	(1) kills the slave threads, by signalling and
+ * 	     waiting for them to be reaped.
+ *	(2) Removes any queued aios (these may not have been intiated at all).
+ *	(3) Removes any remaining aios for this thread from the hash (these
+ *		have completed but not reaped through aio_suspend).
+ *	All actions protected by kernel lock.
+ */
+void
+kaio_exit(void)
+{
+	struct task_struct 	*p;
+	kaiocb_t 		**khpp;
+	kaio_queue_t		*kq;
+	struct list_head 	*tmp;
+	kaiocb_t 		*curr, *next;
+
+	lock_kernel();
+
+	/* kill all slaves if last clone */
+
+	kq = KAIO_INFO(current);
+	if (kq->kaioqref != 1) {
+		kq->kaioqref--;
+		unlock_kernel();
+		return;
+	}
+	/*
+	 * Last reference, kill all slaves & cleanup pending I/Os.
+	 */
+
+	for_each_task(p) {
+		/*
+		 * Look for slaves by name.
+		 */
+		if (p->mm == current->mm &&
+		     strncmp(&p->comm[0], KAIO_SLAVE_NAME,
+			     KAIO_SLAVE_NAMELEN) == 0)
+		{ 
+			send_sig(SIGKILL, p, 1);
+		}
+	}
+	/* kernel lock held for the test below */
+	while (kq->kaioq_nslaves != 0)
+		down(&kq->kaioq_exit_sem);
+	/*
+	 * Any queued aios can be simply "completed" & garbage collected. 
+	 */
+	for (tmp = kq->kaioq.prev; tmp != &kq->kaioq; tmp = kq->kaioq.prev) {
+		list_del(tmp);
+		kaio_io_complete(list_entry(tmp, struct kaiocb, kaio_ioq),
+					-1, -1, 1);
+	}
+	/*
+	 * Free up all hashed aios for this pid; these are already complete,
+	 * but pending aio_suspend.
+	 */
+	unlock_kernel();
+	spin_lock(&kaio_hash_lock);
+	for (khpp = &kaio_hash_table[0];
+		khpp < &kaio_hash_table[kaio_hash_table_size]; khpp++)
+	{
+
+		for  (curr = *khpp; curr; curr = next) {
+			next = curr->kaio_h_next;
+			if (curr->kaio_kq == kq) {
+				kaio_remove_hash(curr);
+				kfree(curr);
+			}
+		}
+	}
+	spin_unlock(&kaio_hash_lock);
+	kfree(kq);
+}
+
+#define KAIO_DO_FOP(op, k)  {						      \
+	int ret;							      \
+	(k)->kaio_filp->f_pos = (k)->kaio_offset;                             \
+	ret = (k)->kaio_filp->f_op-> ## op ((k)->kaio_filp,                   \
+		(k)->kaio_buf, (k)->kaio_nbytes, &(k)->kaio_filp->f_pos);     \
+	kaio_io_complete((k), ret < 0 ? 0 : ret, ret > 0 ? 0 : ret, 0);	      \
+}
+/*		(k)->kaio_buf, (k)->kaio_nbytes, &(k)->kaio_offset);     \ */
+
+static void
+kaio_set_slave_name(void)
+{
+	char newcomm[16];
+
+	sprintf(newcomm, "%s%05d", KAIO_SLAVE_NAME, current->p_pptr->pid);
+	strcpy(current->comm, newcomm);
+	current->mm->arg_start = current->mm->arg_end = 0;
+}
+
+/* Called from kaio_slave to do AIOCMD_<syscall> requests */
+asmlinkage long sys_ioctl(unsigned int fd, unsigned int cmd, unsigned long arg);
+static void
+kaio_do_syscall(kaiocb_t *kaiocb)
+{
+        int ret;
+
+        switch (kaiocb->kaio_cmd) {
+        case AIOCMD_IOCTL:
+                ret = sys_ioctl(kaiocb->kaio_fd, kaiocb->kaio_nbytes,
+                                (unsigned long) kaiocb->kaio_buf);
+                break;
+        case AIOCMD_CLOSE:
+                ret = sys_close(kaiocb->kaio_fd);
+                break;
+        default:
+                ret = -EINVAL;
+                break;
+        }
+
+        kaio_io_complete(kaiocb, ret<0? 0:ret,  ret>0? 0:ret, 0);
+        return;
+}
+
+/*
+ * kaio_slave:
+ * 	Entry point for slave threads that service queued I/O requests.
+ * For each task that employs async I/O there may be several slave threads.
+ * 
+ *	The main function of the slave threads is to wait & dequeue an I/O
+ * request and serice it. Requests may be split-phase with a seperate initiate
+ * and wait routine, or with a unified routine that does both.  Not all
+ * file systems support split-phase requests; only raw I/O directly support it.
+ * Additionally, for file systems that employ generic_read we can use
+ * the recoded kaio_generic_read & associated wait (kaio_slave_suspend).
+ *	
+ *	Slave threads are explicitly started by the library, but are killed
+ * when the "parent" task (that initiates I/O) exits (kaio_exit).
+ */
+void
+kaio_slave()
+{
+	kaiocb_t *kaiocb;
+	kaio_queue_t *kq;
+
+	if (current->p_pptr->pid == 1) { /* too late */
+		unlock_kernel();
+		return;
+	}
+
+	kaio_set_slave_name();
+	kq = KAIO_INFO(current->p_pptr); /* service parent's kaio queue */
+        if (! kq) {    
+                unlock_kernel();
+                return;
+        }
+	KAIO_INFO(current) = 0; /* so kaio_exit does not trip */
+	kq->kaioqref--;
+	if (kq->kaioq_nslaves == -1)
+		kq->kaioq_nslaves = 1; /* initialize it */
+	else
+		kq->kaioq_nslaves++;
+	unlock_kernel();
+
+drain_io:
+	while ((kaiocb = kaio_dequeue(kq))) { /* blocks */
+                kaio_set_time(kaiocb, AIOTIME_DEQUEUED);
+#if defined(CONFIG_RAW)
+		if (kaio_is_raw(kaiocb->kaio_filp))
+			do_raw_wait(kaiocb);
+		else
+#endif
+		{
+			switch (kaiocb->kaio_cmd) {
+			case AIOCMD_GENERIC_READ:
+				kaio_slave_suspend(kaiocb);
+				break;
+			case AIOCMD_READ:
+				KAIO_DO_FOP(read, kaiocb);
+				break;
+		        case AIOCMD_WRITE: {
+		        	KAIO_DO_FOP(write, kaiocb);
+				break;
+			}
+                        /*
+                        case AIOCMD_WRITE: {
+                            /* TODO: for O_APPEND files, write
+                               requests must be done in the submission
+                               order.  Howto?  --sizif * /
+                            loff_t pos = kaiocb->kaio_offset;
+                            int ret = kaiocb->kaio_filp->f_op->write
+                                (kaiocb->kaio_filp,
+                                 kaiocb->kaio_buf,
+                                 kaiocb->kaio_nbytes,
+                                 &pos);
+                            kaiocb->kaio_filp->f_pos = pos;
+                            kaio_set_time(kaiocb, AIOTIME_IO);
+                            kaio_io_complete(kaiocb,
+                                             ret<0? 0:ret,
+                                             ret>0? 0:ret, 0);
+                            break;
+                        }
+                        */
+                        case AIOCMD_IOCTL:
+                        case AIOCMD_CLOSE:
+                                kaio_do_syscall(kaiocb);
+                                break;
+			default:
+				kaio_io_complete(kaiocb, 0, -EINVAL, 0);
+			}
+		}
+	}
+
+	spin_lock(&kq->kaioq_lock);
+	if (atomic_read(&kq->kaiosem.count) > 0) {
+		/*
+		 * There are queued I/Os; process them now.
+		 */
+		spin_unlock(&kq->kaioq_lock);
+		goto drain_io;
+	}
+	lock_kernel();
+	kq->kaioq_nslaves--;
+	spin_unlock(&kq->kaioq_lock);
+	up(&kq->kaioq_exit_sem);
+	unlock_kernel();
+}
+
+/*
+ * This is an asynchronous generic file read routine, and uses the
+ * inode->i_op->readpage() function for the actual low-level stuff.
+ */
+static inline int
+do_kaio_generic_read(struct file * filp, kaiocb_t *kaiocb)
+{
+	struct inode *inode = filp->f_dentry->d_inode;
+	size_t pos;
+	struct address_space *mapping = inode->i_mapping;
+	struct page **hash, *page, *page_cache;
+	int i, ret = 0, npages;
+
+	pos = kaiocb->kaio_offset;
+
+	if (pos >= inode->i_size) {
+		/*
+		 * No I/O possible; specified offset beyond file end
+		 */
+		return -EINVAL;
+	}
+
+	i = pos + kaiocb->kaio_nbytes - 1; /* last byte in I/O */
+	if (i > inode->i_size)
+		i = inode->i_size;
+	npages = pageof(i) - pageof(pos) + 1;
+	/*
+	 * Allocate space to hold page pointers.
+	 */
+	if (npages == 1)
+		kaiocb->kaio_pages = &kaiocb->kaio_page_inline;
+	else {
+		kaiocb->kaio_pages =
+			kmalloc(sizeof(struct page *) * npages, GFP_KERNEL);
+		if (!kaiocb->kaio_pages) 
+			return -EAGAIN;
+	}
+	page_cache = 0;
+	pos = pageof(pos) * PAGE_SIZE;
+	for (i = 0; i < npages; i++, pos += PAGE_SIZE) {
+
+retry:
+		/*
+		 * Try to find the data in the page cache..
+		 */
+		hash = page_hash(mapping, pageof(pos));
+		spin_lock(&pagecache_lock);
+		page = __find_page_nolock(mapping, pageof(pos), *hash);
+		if (page) {
+			get_page(page);
+			kaiocb->kaio_pages[i] = page;
+			spin_unlock(&pagecache_lock);
+			continue;
+		}
+
+		/*
+		 * Ok, it wasn't cached, so we need to create a new
+		 * page.. or reuse a page previously allocated,
+		 * and did not use in retry path below (found page in
+		 * hash after allocation).
+		 */
+		if (!page_cache) {
+			spin_unlock(&pagecache_lock);
+			page_cache = page_cache_alloc(mapping);
+			/*
+			 * That could have slept, so go around to the
+			 * very beginning..
+			 */
+			if (page_cache)
+				goto retry;
+			ret = -ENOMEM;
+			break;
+		}
+
+		/*
+		 * Ok, add the new page to the page cache.
+		 */
+		page = page_cache;
+		__add_to_page_cache(page, mapping, pageof(pos), hash);
+		spin_unlock(&pagecache_lock);
+		page_cache = 0;
+		kaiocb->kaio_pages[i] = page;
+
+		/*
+		 * Fire off the I/O; read page may also add page's
+		 * bufferheads to buffer cache.
+		 */
+		if ((ret = mapping->a_ops->readpage(filp, page)))
+			break;
+		run_task_queue(&tq_disk); /* XXX - improves perf. but why ??*/
+	}
+	if (!ret) {
+		kaiocb->kaio_npages = npages;
+		ret = kaio_enqueue(KAIO_INFO(current), kaiocb);
+	}
+	if (ret) { /* recheck return from kaio_enqueue */
+		for (i--; i >=0; i--) {
+			assert(kaiocb->kaio_pages[i]);
+			page_cache_free(kaiocb->kaio_pages[i]);
+		}
+		if (kaiocb->kaio_pages != &kaiocb->kaio_page_inline)
+			kfree(kaiocb->kaio_pages);
+	}
+	if (page_cache)
+		page_cache_free(page_cache);
+	UPDATE_ATIME(inode);
+	return ret;
+}
+
+/*
+ * Initiate buffered async I/O (e.g. file systems).
+ *
+ * Kaiocb describing the I/O is queued as part of a per-task queue (KAIO_INFO).
+ * I/O is actually initiated only in the case of generic_read. For all
+ * other cases, slave threads initiate and wait for queued requests.
+ *
+ */
+static inline int
+do_kaio_fs_rw(int cmd, struct file *filp, struct kaiocb *kaiocb)
+{
+	/*
+	 * if read request & the fop operation is generic,
+	 * use our own parallel async version; for all other
+	 * reads & for writes, asynchronize by queuing f_op to be
+	 * executed directly by slave.
+	 */
+	if (cmd == AIOCMD_READ && filp->f_op->read == generic_file_read) {
+		kaiocb->kaio_cmd = AIOCMD_GENERIC_READ;
+		return(do_kaio_generic_read(filp, kaiocb));
+	} else {
+		return(kaio_enqueue(KAIO_INFO(current), kaiocb));
+	}
+}
+
+/*
+ * kaio_rw: Initiate async I/O read or write.
+ *
+ *	cmd 	= AIOCMD_{READ,WRITE}; ignored for listio.
+ *	uaiocb 	= user space address of aiocb describing request.
+ *	liocb 	= if not null then part of a list io. 
+ *
+ * Kernel lock held across this function. If I/O successfully queued,
+ * kaiocb holds reference to file (with fget, correspoding fput will be done
+ * at io completion/cancellation/exit). Kaiocb also holds references to the
+ * requesting task, the uaiocb (for transmitting back return/error values),
+ * and liocb, if any. A unique id, representing the  kaiocb in a hash table,
+ * is "returned" back to user on successful queueing.
+ *
+ */
+int
+kaio_rw(int cmd, aiocb_t *uaiocb, liocb_t *liocb)
+{
+	struct file 	*filp = NULL;
+	aiocb_t		aiocb;
+	int 		ret = 0;
+	kaiocb_t 	*kaiocb = NULL;
+
+
+	if (copy_from_user(&aiocb, uaiocb, sizeof(aiocb_t)))
+		return -EFAULT;
+
+	if (kaio_nr_hashed > CONFIG_AIO_MAX) {
+		ret = -EAGAIN;
+		goto rw_error;
+	}
+	if (liocb) {
+		switch (aiocb.aio_lio_opcode) {
+		case LIO_READ:
+			cmd = AIOCMD_READ;
+			break;
+		case LIO_WRITE:
+			cmd = AIOCMD_WRITE;
+			break;
+		case LIO_NOP:
+			/*
+			 * No easy way to return to caller an
+			 * indication to ignore; so, alternately,
+			 * mark as complete.
+			 */
+			if (!lio_complete(liocb, 1, 0))
+				unlock_kernel(); /* not really sleeping */
+			return 0;
+		default:
+			ret =  -EINVAL;
+			goto rw_error;
+		}
+	}
+	if (!(filp = fget(aiocb.aio_fildes))) {
+		ret = -EBADF;
+		goto rw_error;
+	}
+	if (!(filp->f_mode &
+		(cmd == AIOCMD_READ ? FMODE_READ: FMODE_WRITE)))
+	{
+		ret = -EBADF;
+		goto rw_error;
+	}
+	if (aiocb.aio_nbytes) {
+
+		kaiocb = kmalloc(sizeof(kaiocb_t), GFP_KERNEL);
+		if (!kaiocb) {
+			ret = -EAGAIN;
+			goto rw_error;
+		}
+		kaiocb->kaio_filp = filp;
+		kaiocb->kaio_buf = aiocb.aio_buf;
+		kaiocb->kaio_nbytes = aiocb.aio_nbytes;
+		kaiocb->kaio_offset = aiocb.aio_offset;
+		kaiocb->kaio_sigevent = aiocb.aio_sigevent;
+		kaiocb->kaio_task = current;
+		kaiocb->kaio_kq = KAIO_INFO(current);
+		kaiocb->kaio_uaiocb = uaiocb;
+		kaiocb->kaio_cmd = cmd;
+		kaiocb->kaio_liocb = liocb;
+		kaiocb->kaio_pages = 0;
+#ifdef KAIO_STATS
+                memset(kaiocb->kaio_times, 0, sizeof (kaiocb->kaio_times));
+#endif
+                if (cmd == AIOCMD_READ &&
+			!access_ok(VERIFY_WRITE, aiocb.aio_buf, aiocb.aio_nbytes))
+		{
+			ret = -EFAULT;
+			goto rw_error;
+		}
+		ret = locks_verify_area(cmd == AIOCMD_READ ?
+					FLOCK_VERIFY_READ : FLOCK_VERIFY_WRITE,
+					filp->f_dentry->d_inode, filp,
+					aiocb.aio_offset, aiocb.aio_nbytes);
+		if (ret)
+			goto rw_error;
+#if defined(CONFIG_RAW)
+		if (kaio_is_raw(filp))
+			ret = do_kaio_raw_rw(cmd, filp, kaiocb);
+		else
+#endif
+			ret = do_kaio_fs_rw(cmd, filp, kaiocb);
+	}
+	if (!ret) {
+		kaio_key_t kkey;
+
+		kkey.kaio_kid = kaiocb->kaio_id;
+		kkey.kaio_kq = current->kaio_info;
+
+		if (copy_to_user(&uaiocb->aio_key, &kkey, sizeof(kkey)))
+			ret = -EFAULT;
+	}
+rw_error:
+	if (ret) {
+		if (filp)
+			fput(filp);
+		if (kaiocb)
+			kfree(kaiocb);
+	}
+	if (liocb && ret) {
+		/*
+		 * Have to set individual errors for list io
+		 */
+		 (void) put_user(-ret, &uaiocb->aio_error);
+	}
+	return ret;
+}
+
+int
+kaio_syscall(int cmd, aiocb_t *uaiocb)
+{
+        struct file     *filp = NULL;
+        aiocb_t         aiocb;
+        int             ret = 0;
+        kaiocb_t        *kaiocb = NULL;
+
+
+        if (copy_from_user(&aiocb, uaiocb, sizeof(aiocb_t)))
+                return -EFAULT;
+        if (!(filp = fget(aiocb.aio_fildes)))
+                return -EBADF;
+
+        kaiocb = kmalloc(sizeof(kaiocb_t), GFP_KERNEL);
+        if (!kaiocb) {
+                ret = -EAGAIN;
+                goto error;
+        }
+        kaiocb->kaio_fd = aiocb.aio_fildes;
+        kaiocb->kaio_filp = filp;
+        kaiocb->kaio_buf = aiocb.aio_buf;
+        kaiocb->kaio_nbytes = aiocb.aio_nbytes;
+        kaiocb->kaio_offset = aiocb.aio_offset;
+        kaiocb->kaio_sigevent = aiocb.aio_sigevent;
+        kaiocb->kaio_task = current;
+        kaiocb->kaio_kq = KAIO_INFO(current);
+        kaiocb->kaio_uaiocb = uaiocb;
+        kaiocb->kaio_cmd = cmd;
+        kaiocb->kaio_liocb = NULL;
+        kaiocb->kaio_pages = 0;
+#ifdef KAIO_STATS
+        memset(kaiocb->kaio_times, 0, sizeof (kaiocb->kaio_times));
+#endif
+
+        ret = kaio_enqueue(KAIO_INFO(current), kaiocb);
+        if (!ret) {
+                kaio_key_t kkey;
+
+                kkey.kaio_kid = kaiocb->kaio_id;
+                kkey.kaio_kq = current->kaio_info;
+
+                if (copy_to_user(&uaiocb->aio_key, &kkey, sizeof(kkey)))
+                        ret = -EFAULT;
+        }
+ error:
+        if (ret) {
+                if (filp)
+                        fput(filp);
+                if (kaiocb)
+                        kfree(kaiocb);
+        }
+        return ret;
+}
+
+static void
+kaio_set_list_errors(aiocb_t *list[], int nent, int error)
+{
+	int	i;
+	aiocb_t *uaiocbp;
+
+	/*
+	 * Have to set individual errors for each aiocb.
+	 */
+	for (i = 0; i < nent; i++)
+		if (get_user(uaiocbp, &list[i]) == 0 && uaiocbp)
+			 (void) put_user(-error, &uaiocbp->aio_error);
+}
+
+int
+kaio_list_io(int mode, struct aiocb *list[], int nent, sigevent_t *sig)
+{
+	liocb_t *liocb;
+	aiocb_t *aiocbp;
+	int	i = 0, ret = 0, ignore = 0, error = 0;
+
+	liocb = kmalloc(sizeof(liocb_t), GFP_KERNEL);
+	if (!liocb) {
+		ret = -EAGAIN;
+		kaio_set_list_errors(list, nent, ret);
+		return ret;
+	}
+
+	liocb->lio_lock = SPIN_LOCK_UNLOCKED;
+	liocb->lio_nent = nent;
+	liocb->lio_done = 0;
+	liocb->lio_mode = mode;
+	init_waitqueue_head(&liocb->lio_wait);
+	liocb->lio_task = current;
+	if (sig) {
+		if (copy_from_user(&liocb->lio_sigevent,
+			sig, sizeof(sigevent_t)))
+		{
+			ret =  -EFAULT;
+			kaio_set_list_errors(list, nent, ret);
+			error = nent; /* all are in error */
+			goto lio_error;
+		}
+	} else
+		liocb->lio_sigevent.sigev_notify = SIGEV_NONE;
+	for ( ; i < nent; i++) {
+		if (get_user(aiocbp, &list[i])) {
+			ret = -EFAULT;
+			error++;
+			continue;
+		}
+		if (!aiocbp) {
+			ignore++;
+			continue;
+		}
+		/* 0 == cmd for kaio_rw derived from aiocbp */
+		if ((ret = kaio_rw(0, aiocbp, liocb)))
+			error++;
+	}
+	if (!error) {
+		if (!lio_complete(liocb, ignore, 0)) {
+			if (mode == LIO_WAIT)
+				interruptible_sleep_on(&liocb->lio_wait);
+			unlock_kernel();
+		}
+		if (mode == LIO_WAIT)
+			kfree(liocb);
+		return 0;
+	}
+lio_error:
+	if (!lio_complete(liocb, (ignore + error), 0)) {
+		/* pending I/O's; but we are not interested */
+		liocb->lio_mode = LIO_NOWAIT;
+		liocb->lio_sigevent.sigev_notify = SIGEV_NONE;
+		unlock_kernel();
+	} else if (mode != LIO_NOWAIT) {
+		/* if no wait then lio_complete frees liocb */
+		kfree(liocb);
+	}
+	return ret;
+}
+#endif /* CONFIG_AIO */
 
 /*
  * This is the "read()" routine for all filesystems
